;        
; Nick's Led Zeppelin Demo, Version "Sucky"
;
; Compiles with DASM 2.02

	processor 6502
	include vcs.h

		org $f000
NOTE EQU $80

;
; I will make the screen visible so I can see how fast things
; are happening.
;
START   LDA #0
		STA AUDV0
		STA AUDV1
		STA NOTE
		STA VBLANK ;The vertical blank is not processed
		STA VSYNC  ;at all in this program.
		STA COLUBK
		LDA #$0F
		STA COLUPF
MAINLOOP
		LDA #127
		STA T1024T
		LDA NOTE
		AND #$0F
		TAX
		ROL
		ROL
		ROL
		ROL
		STA PF2
		LDA PTCHDATA,X
		STA AUDF0
		STA PF0
		LDA TYPEDATA,X
		STA AUDC0
		STA PF1
		; Distortion 1 is considerably
		; louder than distortion 6, the
		; following three lines of code will
		; compensate for that before placing
		; it in the volume register.  I might
		; just do a TAX and index for it if
		; I need other distortions that are
		; less condusive to calculation.
		AND #4
		CLC
		ADC #4
		STA AUDV0
WAITUM          LDX INTIM
		BNE WAITUM
		; Decrease volume a little bit.
		SBC #2
		STA AUDV0
		; Wait just a little while longer.
		LDX #100
		STX T1024T
WAITEE          LDX INTIM
		BNE WAITEE
		INC NOTE
		JMP MAINLOOP
;
; Pitch data.  Currently only 16 notes are written, and depending
; on how the rest of the song goes I might not even be able to use
; this key anyway.  The last four notes of this bar will be changed
; to represent the second guitar before this is done.
;
PTCHDATA
	dc.b 23,15,15,18,15,27,15,29
	dc.b 23,15,23,29,23,15,23,29
TYPEDATA
	dc.b 06,06,06,06,06,01,06,01
	dc.b 06,06,06,01,06,06,06,01

	org $f7fa
	dc.w START
	dc.w START
	dc.w START

